package com.dhcc.finance.config;

import org.springframework.cloud.client.loadbalancer.LoadBalanced;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.client.RestTemplate;

@Configuration
public class RestTemplateConfig {
	
	@Bean( name="loadBalancedRestTemplate" )
	@LoadBalanced
	public RestTemplate loadBalancedRestTemplate() {
		return new RestTemplate();
	}
	
	@Bean( name="restTemplate" )
	public RestTemplate restTemplate() {
		return new RestTemplate();
	}
}
