package com.dhcc.finance.main.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class CwGlWeightedExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwGlWeightedExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andPkWeightedIsNull() {
            addCriterion("PK_WEIGHTED is null");
            return (Criteria) this;
        }

        public Criteria andPkWeightedIsNotNull() {
            addCriterion("PK_WEIGHTED is not null");
            return (Criteria) this;
        }

        public Criteria andPkWeightedEqualTo(String value) {
            addCriterion("PK_WEIGHTED =", value, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedNotEqualTo(String value) {
            addCriterion("PK_WEIGHTED <>", value, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedGreaterThan(String value) {
            addCriterion("PK_WEIGHTED >", value, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedGreaterThanOrEqualTo(String value) {
            addCriterion("PK_WEIGHTED >=", value, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedLessThan(String value) {
            addCriterion("PK_WEIGHTED <", value, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedLessThanOrEqualTo(String value) {
            addCriterion("PK_WEIGHTED <=", value, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedLike(String value) {
            addCriterion("PK_WEIGHTED like", value, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedNotLike(String value) {
            addCriterion("PK_WEIGHTED not like", value, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedIn(List<String> values) {
            addCriterion("PK_WEIGHTED in", values, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedNotIn(List<String> values) {
            addCriterion("PK_WEIGHTED not in", values, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedBetween(String value1, String value2) {
            addCriterion("PK_WEIGHTED between", value1, value2, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andPkWeightedNotBetween(String value1, String value2) {
            addCriterion("PK_WEIGHTED not between", value1, value2, "pkWeighted");
            return (Criteria) this;
        }

        public Criteria andXtxmbhIsNull() {
            addCriterion("XTXMBH is null");
            return (Criteria) this;
        }

        public Criteria andXtxmbhIsNotNull() {
            addCriterion("XTXMBH is not null");
            return (Criteria) this;
        }

        public Criteria andXtxmbhEqualTo(String value) {
            addCriterion("XTXMBH =", value, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhNotEqualTo(String value) {
            addCriterion("XTXMBH <>", value, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhGreaterThan(String value) {
            addCriterion("XTXMBH >", value, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhGreaterThanOrEqualTo(String value) {
            addCriterion("XTXMBH >=", value, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhLessThan(String value) {
            addCriterion("XTXMBH <", value, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhLessThanOrEqualTo(String value) {
            addCriterion("XTXMBH <=", value, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhLike(String value) {
            addCriterion("XTXMBH like", value, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhNotLike(String value) {
            addCriterion("XTXMBH not like", value, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhIn(List<String> values) {
            addCriterion("XTXMBH in", values, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhNotIn(List<String> values) {
            addCriterion("XTXMBH not in", values, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhBetween(String value1, String value2) {
            addCriterion("XTXMBH between", value1, value2, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtxmbhNotBetween(String value1, String value2) {
            addCriterion("XTXMBH not between", value1, value2, "xtxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhIsNull() {
            addCriterion("XTZXMBH is null");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhIsNotNull() {
            addCriterion("XTZXMBH is not null");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhEqualTo(String value) {
            addCriterion("XTZXMBH =", value, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhNotEqualTo(String value) {
            addCriterion("XTZXMBH <>", value, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhGreaterThan(String value) {
            addCriterion("XTZXMBH >", value, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhGreaterThanOrEqualTo(String value) {
            addCriterion("XTZXMBH >=", value, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhLessThan(String value) {
            addCriterion("XTZXMBH <", value, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhLessThanOrEqualTo(String value) {
            addCriterion("XTZXMBH <=", value, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhLike(String value) {
            addCriterion("XTZXMBH like", value, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhNotLike(String value) {
            addCriterion("XTZXMBH not like", value, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhIn(List<String> values) {
            addCriterion("XTZXMBH in", values, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhNotIn(List<String> values) {
            addCriterion("XTZXMBH not in", values, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhBetween(String value1, String value2) {
            addCriterion("XTZXMBH between", value1, value2, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andXtzxmbhNotBetween(String value1, String value2) {
            addCriterion("XTZXMBH not between", value1, value2, "xtzxmbh");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIsNull() {
            addCriterion("SUBJCODE is null");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIsNotNull() {
            addCriterion("SUBJCODE is not null");
            return (Criteria) this;
        }

        public Criteria andSubjcodeEqualTo(String value) {
            addCriterion("SUBJCODE =", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotEqualTo(String value) {
            addCriterion("SUBJCODE <>", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeGreaterThan(String value) {
            addCriterion("SUBJCODE >", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeGreaterThanOrEqualTo(String value) {
            addCriterion("SUBJCODE >=", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLessThan(String value) {
            addCriterion("SUBJCODE <", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLessThanOrEqualTo(String value) {
            addCriterion("SUBJCODE <=", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLike(String value) {
            addCriterion("SUBJCODE like", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotLike(String value) {
            addCriterion("SUBJCODE not like", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIn(List<String> values) {
            addCriterion("SUBJCODE in", values, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotIn(List<String> values) {
            addCriterion("SUBJCODE not in", values, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeBetween(String value1, String value2) {
            addCriterion("SUBJCODE between", value1, value2, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotBetween(String value1, String value2) {
            addCriterion("SUBJCODE not between", value1, value2, "subjcode");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNull() {
            addCriterion("START_DATE is null");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNotNull() {
            addCriterion("START_DATE is not null");
            return (Criteria) this;
        }

        public Criteria andStartDateEqualTo(Date value) {
            addCriterionForJDBCDate("START_DATE =", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("START_DATE <>", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThan(Date value) {
            addCriterionForJDBCDate("START_DATE >", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("START_DATE >=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThan(Date value) {
            addCriterionForJDBCDate("START_DATE <", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("START_DATE <=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateIn(List<Date> values) {
            addCriterionForJDBCDate("START_DATE in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("START_DATE not in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("START_DATE between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("START_DATE not between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("END_DATE is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("END_DATE is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("END_DATE =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("END_DATE <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("END_DATE >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("END_DATE >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(Date value) {
            addCriterionForJDBCDate("END_DATE <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("END_DATE <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("END_DATE in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("END_DATE not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("END_DATE between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("END_DATE not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysIsNull() {
            addCriterion("WEIGHTED_DAYS is null");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysIsNotNull() {
            addCriterion("WEIGHTED_DAYS is not null");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysEqualTo(BigDecimal value) {
            addCriterion("WEIGHTED_DAYS =", value, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysNotEqualTo(BigDecimal value) {
            addCriterion("WEIGHTED_DAYS <>", value, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysGreaterThan(BigDecimal value) {
            addCriterion("WEIGHTED_DAYS >", value, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("WEIGHTED_DAYS >=", value, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysLessThan(BigDecimal value) {
            addCriterion("WEIGHTED_DAYS <", value, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysLessThanOrEqualTo(BigDecimal value) {
            addCriterion("WEIGHTED_DAYS <=", value, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysIn(List<BigDecimal> values) {
            addCriterion("WEIGHTED_DAYS in", values, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysNotIn(List<BigDecimal> values) {
            addCriterion("WEIGHTED_DAYS not in", values, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("WEIGHTED_DAYS between", value1, value2, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedDaysNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("WEIGHTED_DAYS not between", value1, value2, "weightedDays");
            return (Criteria) this;
        }

        public Criteria andWeightedBalIsNull() {
            addCriterion("WEIGHTED_BAL is null");
            return (Criteria) this;
        }

        public Criteria andWeightedBalIsNotNull() {
            addCriterion("WEIGHTED_BAL is not null");
            return (Criteria) this;
        }

        public Criteria andWeightedBalEqualTo(BigDecimal value) {
            addCriterion("WEIGHTED_BAL =", value, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andWeightedBalNotEqualTo(BigDecimal value) {
            addCriterion("WEIGHTED_BAL <>", value, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andWeightedBalGreaterThan(BigDecimal value) {
            addCriterion("WEIGHTED_BAL >", value, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andWeightedBalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("WEIGHTED_BAL >=", value, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andWeightedBalLessThan(BigDecimal value) {
            addCriterion("WEIGHTED_BAL <", value, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andWeightedBalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("WEIGHTED_BAL <=", value, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andWeightedBalIn(List<BigDecimal> values) {
            addCriterion("WEIGHTED_BAL in", values, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andWeightedBalNotIn(List<BigDecimal> values) {
            addCriterion("WEIGHTED_BAL not in", values, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andWeightedBalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("WEIGHTED_BAL between", value1, value2, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andWeightedBalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("WEIGHTED_BAL not between", value1, value2, "weightedBal");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}