package com.dhcc.finance.main.model;

import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class SysPostInfo {
    
	@ApiModelProperty(value = "岗位编号", required = true, example = "234243435454")
    private String postId;

    @ApiModelProperty(value = "岗位名称", required = false, example = "部门主管")
    private String postName;

    @ApiModelProperty(value = "岗位类别", required = false, example = "1")
    private String postType;

    @ApiModelProperty(value = "使用状态", required = false, example = "1")
    private String useState;

    @ApiModelProperty(value = "新增人", required = false, example = "admin")
    private String intUser;

    @ApiModelProperty(value = "新增时间", required = false, example = "2017-03-20")
    private Date intDate;

    @ApiModelProperty(value = "修改人", required = false, example = "张三")
    private String updUser;

    @ApiModelProperty(value = "修改时间", required = false, example = "206-04-30")
    private Date updDate;

    @ApiModelProperty(value = "与用户关联标志", required = false)
    private String isRel;
}