package com.dhcc.finance.main.domain;

import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@ApiModel(value = "AsDetailContractAssets",description = "合同资产明细表")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class AsDetailContractAssets {
	@ApiModelProperty(value = "id", required = true, example = "")
    private String id;
	@ApiModelProperty(value = "投资资产编号", required = true, example = "")
    private String tzzcbh;
	@ApiModelProperty(value = "委托合同编号", required = true, example = "")
    private String wthtbh;
	@ApiModelProperty(value = "借据编号", required = true, example = "")
    private String jjbh;
	@ApiModelProperty(value = "运用合同编号", required = true, example = "")
    private String yyhtbh;
	@ApiModelProperty(value = "资产入账价值", required = true, example = "")
    private BigDecimal zcrzjz;
	@ApiModelProperty(value = "是否到账", required = true, example = "")
    private String sfdz;
	@ApiModelProperty(value = "到账日期", required = true, example = "")
    private Date dzrq;
	@ApiModelProperty(value = "信托项目编号", required = true, example = "")
    private String xtxmbh;
	@ApiModelProperty(value = "信托项目子编号", required = true, example = "")
    private String xtzxmbh;
	@ApiModelProperty(value = "财产类别", required = true, example = "")
    private String cclb;
}