package com.dhcc.finance.main.domain;

import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
@ApiModel(value = "CwGlInitbuildB",description = "期初余额辅助明细表")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class CwGlInitbuildB {
    @ApiModelProperty(value = "期初余额辅助主键", required = true, example = "")
    private String pkInitbuildB;

    @ApiModelProperty(value = "期初余额主键", required = false, example = "")
    private String pkInitbuild;

    @ApiModelProperty(value = "币种", required = false, example = "")
    private String pkCurrtype;

    @ApiModelProperty(value = "原币借方金额", required = false, example = "")
    private BigDecimal debitamount;

    @ApiModelProperty(value = "原币贷方金额", required = false, example = "")
    private BigDecimal creditamount;

    @ApiModelProperty(value = "本币借方金额", required = false, example = "")
    private BigDecimal localdebitamount;

    @ApiModelProperty(value = "本币贷方金额", required = false, example = "")
    private BigDecimal localcreditamount;

    @ApiModelProperty(value = "辅助核算标识", required = false, example = "")
    private String assid;

    @ApiModelProperty(value = "使用状态", required = false, example = "")
    private String useState;

    @ApiModelProperty(value = "录入人员", required = false, example = "")
    private String createUser;

    @ApiModelProperty(value = "录入时间", required = false, example = "")
    private Date createTime;

    @ApiModelProperty(value = "最后修改人员", required = false, example = "")
    private String updateUser;

    @ApiModelProperty(value = "最后修改时间", required = false, example = "CURRENT_TIMESTAMP")
    private Date updateTime;

    @ApiModelProperty(value = "备注", required = false, example = "")
    private String remark;
    }