package com.dhcc.finance.main.domain;

import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@ApiModel(value = "CwReverseOperation",description = "信托项目信息表（子项目,数据库中的字段是text类型的）")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class PmProjectChildWithBLOBs extends PmProjectChild {
	
	@ApiModelProperty(value = "信托合同约定的信托报酬说明", required = true, example = "")
    private String xtbcsm;

	@ApiModelProperty(value = "业务信息说明", required = true, example = "")
    private String ywxxsm;

	@ApiModelProperty(value = "赎回的限制性条件", required = true, example = "")
    private String shxztj;

	@ApiModelProperty(value = "关联交易补充说明", required = true, example = "")
    private String gljybcsm;

	@ApiModelProperty(value = "关联交易目的", required = true, example = "")
    private String gljymd;

	@ApiModelProperty(value = "关联交易定价", required = true, example = "")
    private String gljydj;

	@ApiModelProperty(value = "备注", required = true, example = "")
    private String beizu;
}
