package com.dhcc.finance.main.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
@ApiModel(value = "BusiBenchangesflowinfo", description = "项目接口返回值")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BusiBenchangesflowinfo {
	/**
     * 流程实例状态
     */
    @ApiModelProperty(value = "流程实例状态", required = true, example = "")
    private String lcslzt;

    /**
     * 申请书编号
     */
    @ApiModelProperty(value = "申请书编号", required = true, example = "")
    private String sqsbh;

    /**
     * 是否走完流程
     */
    @ApiModelProperty(value = "是否走完流程", required = true, example = "")
    private String flowflag;
}
