package com.dhcc.finance.main.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@ApiModel(value = "ChroAccountExportParam", description = "导出请求参数")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ChroAccountExportParam {
    
    @ApiModelProperty(value = "类型", required = false, example = "")
    private String searchType;
    
    @ApiModelProperty(value = "账套", required = false, example = "")
    private String pkGlorgbook;
    
    @ApiModelProperty(value = "信托项目编号", required = false, example = "")
    private String xtxmbh;
    
    @ApiModelProperty(value = "项目单元", required = false, example = "")
    private String cellCode;
    
    @ApiModelProperty(value = "科目", required = false, example = "")
    private String subjcode;
    
    @ApiModelProperty(value = "起始日期", required = false, example = "")
    private String beginDate;
    
    @ApiModelProperty(value = "截止日期", required = false, example = "")
    private String endDate;

}
