package com.dhcc.finance.main.model;

import java.util.Date;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
/**
 * 功能描述：修改凭证模板分录信息实体类
 * @author dml
 * @date 2019年4月4日 下午8:36:23
 * @修改日志：
 */
@ApiModel(value = "CwBdVouchtempBAdd",description = "修改凭证模板分录信息实体类")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class CwBdVouchtempBUpd {
    @ApiModelProperty(value = "分录主键", required = true, example = "")
    private String pkVouchtempB;

    @ApiModelProperty(value = "凭证模板主键", required = false, example = "")
    private String pkVouchtemp;

    @ApiModelProperty(value = "摘要", required = false, example = "")
    private String abstracts;

    @ApiModelProperty(value = "科目编码", required = false, example = "")
    private String pkAccsubj;

    @ApiModelProperty(value = "科目名称", required = false, example = "")
    private String subjname;

    @ApiModelProperty(value = "借贷方向", required = false, example = "")
    private String direction;

    @ApiModelProperty(value = "币种", required = false, example = "")
    private String pkCurrtype;

    @ApiModelProperty(value = "原币金额", required = false, example = "")
    private String orimoney;

    @ApiModelProperty(value = "本币金额", required = false, example = "")
    private String basemoney;

    @ApiModelProperty(value = "使用状态", required = false, example = "")
    private String useState;

    @ApiModelProperty(value = "录入人员", required = false, example = "")
    private String createUser;

    @ApiModelProperty(value = "录入时间", required = false, example = "")
    private Date createTime;

    @ApiModelProperty(value = "最后修改人员", required = false, example = "")
    private String updateUser;

    @ApiModelProperty(value = "最后修改时间", required = false, example = "CURRENT_TIMESTAMP")
    private Date updateTime;

    @ApiModelProperty(value = "多分录标志", required = false, example = "")
    private String multipleType;
    
    @ApiModelProperty(value = "备注", required = false, example = "")
    private String remark;
    
    @ApiModelProperty(value = "旧科目编码", required = false, example = "")
    private String oldPkAccsubj;
}
