package com.dhcc.finance.main.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@ApiModel(value = "CwGlTransferExecDetail",description = "结转信息表收入费用金额")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class CwGlTransferExecDetail {
	@ApiModelProperty(value = "科目编码", required = false, example = "")
    private String subjcode;

    @ApiModelProperty(value = "科目名称", required = false, example = "")
    private String subjname;
    
    @ApiModelProperty(value = "借贷方向", required = false, example = "")
    private String balanorient;
    
    @ApiModelProperty(value = "余额", required = false, example = "")
    private String balance;
}
