package com.dhcc.finance.main.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@ApiModel(value = "CwGlVoucherTempRequest", description = "根据模板生成凭证")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class CwGlVoucherTempRequest {

    @ApiModelProperty(value = "序号", required = true, example = "")
    private String index;
    @ApiModelProperty(value = "是否有辅助项", required = true, example = "")
    private boolean hasItem;
    @ApiModelProperty(value = "批次号", required = true, example = "")
    private String batchNo;
    @ApiModelProperty(value = "档案名称", required = true, example = "")
    private String valueName;
    @ApiModelProperty(value = "档案编码", required = true, example = "")
    private String valueCode;
    @ApiModelProperty(value = "来源系统", required = true, example = "")
    private String pkSystem;
    @ApiModelProperty(value = "借贷方向", required = false, example = "")
    private String direction;
    @ApiModelProperty(value = "凭证类型", required = false, example = "")
    private String voucherType;
}
